//
// C++ Interface: eel_macro_types
//
// Description: 
//
//
// Author: Ryan Cunningham <rcunning@cs.ucla.edu>, (C) 2004
//
// Copyright: Ryan Cunningham
//
//

#ifndef EEL_MACRO_TYPES_H
#define EEL_MACRO_TYPES_H

//
// RING macro type
//
#define RING_ENTRY(type)                                               \
struct {                                                               \
  struct type *re_item;                                                \
}
#define RING_INIT(elm, field) do {                                     \
  (elm)->field.re_item = NULL;                                         \
} while (0)
#define RING_INSERT(type, field, e0, e1) do {                          \
  if ((e0)->field.re_item == NULL) {                                   \
    if ((e1)->field.re_item == NULL) {                                 \
      (e0)->field.re_item = (e1);                                      \
      (e1)->field.re_item = (e0);                                      \
    } else {                                                           \
      (e0)->field.re_item = (e1)->field.re_item;                       \
      (e1)->field.re_item = (e0);                                      \
    }                                                                  \
  } else if ((e1)->field.re_item == NULL) {                            \
    (e1)->field.re_item = (e0)->field.re_item;                         \
    (e0)->field.re_item = (e1);                                        \
  } else {                                                             \
    struct type *eNext = (e0)->field.re_item;                          \
    struct type *eCurrent = (e1)->field.re_item;                       \
    (e0)->field.re_item = (e1);                                        \
    for (; eCurrent->field.re_item != (e1);                            \
           eCurrent = eCurrent->field.re_item->field.re_item);         \
    eCurrent->field.re_item = eNext;                                   \
  }                                                                    \
} while (0)
#define RING_FORALLOTHERS(var, elm, field)                             \
  if (elm)                                                             \
    for ((var) = (elm)->field.re_item;                                 \
         (var) && (var) != (elm);                                      \
         (var) = (var)->field.re_item)
         
#endif // EEL_MACRO_TYPES_H
